VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmWS 
   Caption         =   "EI100 Winsock Example"
   ClientHeight    =   3675
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6300
   LinkTopic       =   "Form1"
   ScaleHeight     =   3675
   ScaleWidth      =   6300
   StartUpPosition =   3  'Windows ̊l
   Begin VB.ListBox lstWS 
      Height          =   1860
      Left            =   1860
      TabIndex        =   10
      Top             =   1620
      Width           =   4275
   End
   Begin VB.CommandButton cmdWS 
      Caption         =   "Send"
      Height          =   435
      Left            =   4860
      TabIndex        =   9
      Top             =   360
      Width           =   1155
   End
   Begin VB.TextBox txtWS 
      Alignment       =   1  'E
      Height          =   270
      Index           =   2
      Left            =   1860
      TabIndex        =   6
      Text            =   "S"
      Top             =   1140
      Width           =   4275
   End
   Begin VB.TextBox txtWS 
      Alignment       =   1  'E
      Height          =   270
      Index           =   1
      Left            =   1860
      TabIndex        =   2
      Text            =   "8000"
      Top             =   660
      Width           =   2715
   End
   Begin VB.TextBox txtWS 
      Alignment       =   1  'E
      Height          =   270
      Index           =   0
      Left            =   1860
      TabIndex        =   0
      Text            =   "localhost"
      Top             =   180
      Width           =   2715
   End
   Begin MSWinsockLib.Winsock Ws 
      Left            =   120
      Top             =   3060
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Label lblWS 
      Caption         =   "Response from EI100"
      Height          =   495
      Index           =   3
      Left            =   120
      TabIndex        =   11
      Top             =   1620
      Width           =   1815
   End
   Begin VB.Label lblWSS 
      Caption         =   "e.g.: S | T0 | E | M0, C:\master\master001.jpg"
      BeginProperty Font 
         Name            =   "lr oSVbN"
         Size            =   8.25
         Charset         =   128
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00008000&
      Height          =   255
      Index           =   1
      Left            =   1860
      TabIndex        =   8
      Top             =   1440
      Width           =   4095
   End
   Begin VB.Label lblWS 
      Caption         =   "Command"
      Height          =   195
      Index           =   2
      Left            =   120
      TabIndex        =   7
      Top             =   1200
      Width           =   1815
   End
   Begin VB.Label lblWSS 
      Caption         =   "e.g. : 8000"
      BeginProperty Font 
         Name            =   "lr oSVbN"
         Size            =   8.25
         Charset         =   128
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00008000&
      Height          =   135
      Index           =   0
      Left            =   1860
      TabIndex        =   5
      Top             =   960
      Width           =   2415
   End
   Begin VB.Label lblWSS 
      Caption         =   "e.g. : 192.168.1.0 or localhost"
      BeginProperty Font 
         Name            =   "lr oSVbN"
         Size            =   8.25
         Charset         =   128
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00008000&
      Height          =   135
      Index           =   2
      Left            =   1860
      TabIndex        =   4
      Top             =   480
      Width           =   2415
   End
   Begin VB.Label lblWS 
      Caption         =   "Port No."
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   1815
   End
   Begin VB.Label lblWS 
      Caption         =   "Server IP Address"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   1815
   End
End
Attribute VB_Name = "frmWS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=============================================================
'   Overview    :Example program to communicate w/ EI100
'-------------------------------------------------------------
'   Copyright SKYLOGIQ Co., Ltd 2008
'=============================================================
'You may use the public functions here to easily use the socket
'communication on your program.

Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Const TXT_IPADDR As Integer = 0
Const TXT_PORTNO As Integer = 1
Const TXT_COMMAND As Integer = 2

Private ei100resp As String     'Response from EI100
Private flgDat As Boolean       'True if data arrived
Private flgSendCompl As Boolean 'True if data transmission completed
Private flgConnCompl As Boolean 'True if connection succeeded
Private flgClosCompl As Boolean 'True if port close completed
Private flgErr As Boolean       'True if error occurred

'=============================================================
'   Overview    :Sends a command and returns the response from EI100
'-------------------------------------------------------------
'   Argument    :command: a command to ei100
'   Return      :response from ei100
'=============================================================
Public Function Communicate(command As String) As String
    'Close
    'If Me.Ws.State <> sckClosed Then Me.Ws.Close
    
    flgErr = False
    
    'Connect. IP and port is already set.
    If Me.Ws.State = sckClosed Then
        'IP and port settings
        Me.Ws.RemoteHost = Me.txtWS(TXT_IPADDR).Text
        Me.Ws.RemotePort = CInt(Me.txtWS(TXT_PORTNO).Text)
        
        Call Me.Ws.Connect
        flgConnCompl = False 'reset flag
        
        'Wait for connection
        Do
            If flgConnCompl = True Then Exit Do
            If flgErr = True Then Exit Function
            DoEvents
            Call Sleep(1)
        Loop
    End If
    
    'Send command
    flgSendCompl = False
    flgDat = False
    ei100resp = ""
    Call Me.Ws.SendData(command)
    
    'Wait for data transmission
    Do
        If flgSendCompl = True Then Exit Do
        DoEvents
        Call Sleep(1)
    Loop
    
    'Wait for Response
    Do
        If flgDat = True Then Exit Do
        DoEvents
        Call Sleep(1)
    Loop
    
    'Close Connection
    flgClosCompl = False
    Me.Ws.Close

    'Wait for Closing
    Do
        If Me.Ws.State = sckClosed Then Exit Do
        DoEvents
        Call Sleep(1)
    Loop
    
    'Return ei100 response
    Communicate = ei100resp
    
End Function


'//////////////////////// Events /////////////////////////////

'=============================================================
'   Overview    :Send Button Event
'-------------------------------------------------------------
'   Argument    :None
'   Return      :None
'=============================================================
Private Sub cmdWS_Click()
    Me.cmdWS.Enabled = False
    
    Call Me.lstWS.AddItem(Communicate(Me.txtWS(TXT_COMMAND).Text))
    Me.lstWS.ListIndex = Me.lstWS.ListCount - 1
    
    Me.cmdWS.Enabled = True
    
End Sub

'=============================================================
'   Overview    :Form load event. Initialization etc.
'-------------------------------------------------------------
'   Argument    :None
'   Return      :None
'=============================================================
Private Sub Form_Load()

End Sub

'=============================================================
'   Overview    :Form Unload event. Close connection etc.
'-------------------------------------------------------------
'   Argument    :None
'   Return      :None
'=============================================================
Private Sub Form_Unload(Cancel As Integer)
    'Close connection
    If Me.Ws.State <> sckClosed Then Me.Ws.Close
    
End Sub

'//////////////////////// Winsock Events /////////////////////

'=============================================================
'   Overview    :Conn. Closed by Server event. Close connection etc.
'-------------------------------------------------------------
'   Argument    :None
'   Return      :None
'=============================================================
Private Sub Ws_Close()
    Me.Ws.Close
    
End Sub

'=============================================================
'   Overview    :Conn. Complete event.
'-------------------------------------------------------------
'   Argument    :None
'   Return      :None
'=============================================================
Private Sub Ws_Connect()
    flgConnCompl = True
    
End Sub

'=============================================================
'   Overview    :Data from EI100 arrived event
'-------------------------------------------------------------
'   Argument    :bytesTotal: total bytes
'   Return      :None
'=============================================================
Private Sub Ws_DataArrival(ByVal bytesTotal As Long)
    Dim s As String
    
    'Get Data
    Call Me.Ws.GetData(s)
    ei100resp = ei100resp & s
    
    flgDat = True

End Sub

'=============================================================
'   Overview    :Error event
'-------------------------------------------------------------
'   Argument    :refer to winsock specificatoins
'   Return      :None
'=============================================================
Private Sub Ws_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    MsgBox "frmWS Eror:" & Description, vbExclamation
    flgErr = True
End Sub

'=============================================================
'   Overview    :SendComplete Event
'-------------------------------------------------------------
'   Argument    :None
'   Return      :None
'=============================================================
Private Sub Ws_SendComplete()
    flgSendCompl = True
    
End Sub
